(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     14943,        444]
NotebookOptionsPosition[     13066,        375]
NotebookOutlinePosition[     13594,        398]
CellTagsIndexPosition[     13509,        393]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.4929516574062233`*^9, 3.492951675677423*^9}, 
   3.492951759677071*^9, {3.508239966770268*^9, 3.508239971607451*^9}}],

Cell[BoxData[
 RowBox[{"<<", "h5mma`"}]], "Input",
 CellChangeTimes->{{3.490511229646881*^9, 3.490511234727852*^9}}],

Cell["Available functions", "Text",
 CellChangeTimes->{{3.490529909296783*^9, 3.490529928150577*^9}, 
   3.4996108349094954`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "h5mma`*"}]], "Input",
 CellChangeTimes->{{3.490527640404723*^9, 3.490527645172875*^9}}],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["h5mma`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["h5mma`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["h5mma",
          BaseStyle->"InformationLinkLF",
          ButtonData:>{"Info3508243904-7089979", {"h5mma", "h5mma`"}},
          ButtonNote->"h5mma`"], 
         ButtonBox["ReadDatasetsProgress",
          BaseStyle->"InformationLinkLF",
          
          ButtonData:>{
           "Info3508243904-7089979", {"ReadDatasetsProgress", "h5mma`"}},
          ButtonNote->"h5mma`"]},
        {
         ButtonBox["ImportHDF5",
          BaseStyle->"InformationLinkLF",
          ButtonData:>{"Info3508243904-7089979", {"ImportHDF5", "h5mma`"}},
          ButtonNote->"h5mma`"], 
         ButtonBox["Turbo",
          BaseStyle->"InformationLinkLF",
          ButtonData:>{"Info3508243904-7089979", {"Turbo", "h5mma`"}},
          ButtonNote->"h5mma`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.475]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.508240305058878*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "ImportHDF5"}]], "Input",
 CellChangeTimes->{{3.490529878768306*^9, 3.490529882185398*^9}}],

Cell[BoxData[
 StyleBox["\<\"ImportHDF5[\\\"file\\\"] imports data from an HDF5 file, \
returning a complete \
\!\(\*\\nStyleBox[\\\"Mathematica\\\",\\nFontSlant->\\\"Italic\\\"]\) version \
of it.\\nImportHDF5[\\\"file\\\", \!\(\*\\nStyleBox[\\\"elements\\\", \
\\\"TI\\\"]\)] imports the specified elements from a file.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.508240307143094*^9},
 CellTags->"Info3508243905-7089979"]
}, Open  ]],

Cell["Example", "Text",
 CellChangeTimes->{{3.490529932118734*^9, 3.490529933126587*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$PrePrint", "=", "Short"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"file", "=", "\"\<phi.0.xy.h5\>\""}], ";"}]}], "Input",
 CellChangeTimes->{{3.4899366138854847`*^9, 3.489936623699217*^9}, {
  3.4905267612156076`*^9, 3.490526762646985*^9}, {3.499610856537045*^9, 
  3.4996108575431757`*^9}, {3.499618325163876*^9, 3.499618330227194*^9}}],

Cell["\<\
With no extra arguments, we just list the datasets in the file\
\>", "Text",
 CellChangeTimes->{{3.49052998318314*^9, 3.490529998956534*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ImportHDF5", "[", "file", "]"}]], "Input",
 CellChangeTimes->{{3.4905280543067102`*^9, 3.490528066874321*^9}, 
   3.490529539923633*^9, {3.4905301163225737`*^9, 3.490530119201985*^9}, {
   3.49053014940202*^9, 3.4905301548175793`*^9}, {3.499618304914722*^9, 
   3.4996183179172373`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{"\<\"/CTGBASE::phi it=0 tl=0 m=0 rl=0 c=0\"\>", ",", 
    RowBox[{"\[LeftSkeleton]", "140", "\[RightSkeleton]"}], ",", 
    RowBox[{"\<\"/Parameters \"\>", "\[Ellipsis]", "\<\"id Structure\"\>"}]}],
    "}"}],
  Short]], "Output",
 CellChangeTimes->{{3.499618311615631*^9, 3.499618332602092*^9}, 
   3.499618446322741*^9, {3.499618618698938*^9, 3.499618639471159*^9}, 
   3.499618707807564*^9, 3.508239996489386*^9, 3.5082401314266443`*^9, 
   3.508240307351507*^9}]
}, Open  ]],

Cell["We can load all data:", "Text",
 CellChangeTimes->{{3.499618293456662*^9, 3.4996182977117043`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ImportHDF5", "[", 
  RowBox[{"file", ",", "\"\<Data\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.499618337348248*^9, 3.499618343121159*^9}, {
  3.499618483079171*^9, 3.499618483821973*^9}, {3.508240185778718*^9, 
  3.508240202136775*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0.9853526022944306`", ",", 
        RowBox[{"\[LeftSkeleton]", "97", "\[RightSkeleton]"}], ",", 
        "0.985352575104176`"}], "}"}], ",", 
      RowBox[{"\[LeftSkeleton]", "69", "\[RightSkeleton]"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "}"}]}], "}"}], 
    ",", 
    RowBox[{"\[LeftSkeleton]", "140", "\[RightSkeleton]"}], ",", 
    RowBox[{"\<\"\"\>", "\[Ellipsis]", "\<\"]\"\>"}]}], "}"}],
  Short]], "Output",
 CellChangeTimes->{
  3.499618344733941*^9, 3.4996184481818657`*^9, {3.4996186235023947`*^9, 
   3.499618642312093*^9}, 3.499618719056343*^9, 3.508240000448223*^9, {
   3.508240181805953*^9, 3.508240188959202*^9}, 3.50824022428867*^9, 
   3.508240308172344*^9}]
}, Open  ]],

Cell["We can also specify which datasets to import:", "Text",
 CellChangeTimes->{{3.490530012724098*^9, 3.490530021348151*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ImportHDF5", "[", 
  RowBox[{"file", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<Datasets\>\"", ",", 
     RowBox[{"{", 
      RowBox[{
      "\"\</CTGBASE::phi it=0 tl=0 m=0 rl=0 c=0\>\"", ",", 
       "\"\</CTGBASE::phi it=0 tl=0 m=0 rl=0 c=1\>\""}], "}"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.490525430830884*^9, 3.490525436581707*^9}, {
  3.490525822429739*^9, 3.490525848309379*^9}, {3.490527719859448*^9, 
  3.4905277255177298`*^9}, {3.4905278675598707`*^9, 3.490527876893983*^9}, {
  3.490527960724666*^9, 3.490527976746708*^9}, {3.490528069873969*^9, 
  3.4905280722412157`*^9}, {3.490528174927672*^9, 3.49052817734136*^9}, {
  3.490528255900537*^9, 3.4905282757705107`*^9}, {3.4905301462520943`*^9, 
  3.490530159634848*^9}, {3.499618356018689*^9, 3.499618358422843*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0.9853526022944306`", ",", 
        RowBox[{"\[LeftSkeleton]", "97", "\[RightSkeleton]"}], ",", 
        "0.985352575104176`"}], "}"}], ",", 
      RowBox[{"\[LeftSkeleton]", "69", "\[RightSkeleton]"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\[LeftSkeleton]", "19", "\[RightSkeleton]"}], ",", 
        RowBox[{"\[LeftSkeleton]", "98", "\[RightSkeleton]"}]}], "}"}]}], 
     "}"}], ",", 
    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}], "}"}],
  Short]], "Output",
 CellChangeTimes->{3.49961835885942*^9, 3.499618721854495*^9, 
  3.508240005323675*^9, 3.508240225848127*^9, 3.508240308384021*^9}]
}, Open  ]],

Cell[TextData[{
 "We can also import the attributes (annotations in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "'s language)"
}], "Text",
 CellChangeTimes->{{3.490530082194151*^9, 3.490530098137845*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"allAttrs", "=", 
  RowBox[{"ImportHDF5", "[", 
   RowBox[{"file", ",", "\"\<Annotations\>\""}], "]"}]}]], "Input",
 CellChangeTimes->{{3.490529107533399*^9, 3.490529111873212*^9}, {
   3.490529251237857*^9, 3.490529257805688*^9}, {3.4905301948967123`*^9, 
   3.4905302022000837`*^9}, 3.499618363732176*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\<\"time\"\>", "\[Rule]", "0.`"}], ",", 
      RowBox[{"\<\"timestep\"\>", "\[Rule]", "0"}], ",", 
      RowBox[{"\[LeftSkeleton]", "4", "\[RightSkeleton]"}], ",", 
      RowBox[{"\<\"iorigin\"\>", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "}"}], ",", 
    RowBox[{"\[LeftSkeleton]", "138", "\[RightSkeleton]"}], ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}]}], "}"}],
  Short]], "Output",
 CellChangeTimes->{3.499618364572259*^9, 3.4996187266428833`*^9, 
  3.508240010120081*^9, 3.508240308540679*^9}]
}, Open  ]],

Cell["And we can get the dimensions of a dataset's data", "Text",
 CellChangeTimes->{{3.4930123861571074`*^9, 3.493012394988605*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ImportHDF5", "[", 
  RowBox[{"file", ",", "\"\<Dimensions\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.493012398379175*^9, 3.4930124092291613`*^9}, {
  3.499618369764146*^9, 3.499618371187399*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"71", ",", "99"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"71", ",", "99"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"38", ",", "99"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"35", ",", "37"}], "}"}], ",", 
    RowBox[{"\[LeftSkeleton]", "134", "\[RightSkeleton]"}], ",", 
    RowBox[{"{", 
     RowBox[{"31", ",", "34"}], "}"}], ",", 
    RowBox[{"{", "13823", "}"}], ",", 
    RowBox[{"{", "14", "}"}], ",", 
    RowBox[{"{", "60589", "}"}]}], "}"}],
  Short]], "Output",
 CellChangeTimes->{3.499618371797871*^9, 3.499618728572844*^9, 
  3.5082400165872602`*^9, 3.508240308566073*^9}]
}, Open  ]],

Cell["Finally, we can get the whole lot in one go", "Text",
 CellChangeTimes->{{3.493013609386043*^9, 3.493013616329533*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ImportHDF5", "[", 
  RowBox[{"file", ",", "\"\<Rules\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.493012561799562*^9, 3.493012568984702*^9}, {
   3.4930126029779367`*^9, 3.4930126034245863`*^9}, {3.493012667272015*^9, 
   3.4930126683506613`*^9}, {3.4930127503912582`*^9, 3.493012755106142*^9}, {
   3.493013536263772*^9, 3.493013544300663*^9}, {3.493013619762686*^9, 
   3.493013629754871*^9}, 3.49961692231735*^9, 3.4996183807543716`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"\<\"Annotations\"\>", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\<\"time\"\>", "\[Rule]", "0.`"}], ",", 
         RowBox[{"\<\"timestep\"\>", "\[Rule]", "0"}], ",", 
         RowBox[{"\[LeftSkeleton]", "4", "\[RightSkeleton]"}], ",", 
         RowBox[{"\<\"iorigin\"\>", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}]}]}], "}"}], ",", 
       RowBox[{"\[LeftSkeleton]", "140", "\[RightSkeleton]"}], ",", 
       RowBox[{"{", "}"}]}], "}"}]}], ",", 
    RowBox[{"\[LeftSkeleton]", "3", "\[RightSkeleton]"}]}], "}"}],
  Short]], "Output",
 CellChangeTimes->{3.499616924366172*^9, 3.499617273946602*^9, 
  3.4996173120197983`*^9, 3.4996173425739727`*^9, 3.499618382277507*^9, 
  3.499618731202243*^9, 3.508240019167996*^9, 3.508240309398525*^9}]
}, Open  ]],

Cell["\<\
We can also monitor progress if we want (for larger files)\
\>", "Text",
 CellChangeTimes->{{3.508240053004871*^9, 3.50824006835737*^9}, {
  3.508240260759736*^9, 3.5082402645894012`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Monitor", "[", 
  RowBox[{
   RowBox[{"ImportHDF5", "[", 
    RowBox[{"file", ",", "\"\<Rules\>\""}], "]"}], ",", 
   RowBox[{"ProgressIndicator", "[", "ReadDatasetsProgress", "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.50824004972351*^9, 3.508240074892362*^9}, {
  3.5082402340327253`*^9, 3.5082402522478333`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"\<\"Annotations\"\>", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\<\"time\"\>", "\[Rule]", "0.`"}], ",", 
         RowBox[{"\<\"timestep\"\>", "\[Rule]", "0"}], ",", 
         RowBox[{"\[LeftSkeleton]", "4", "\[RightSkeleton]"}], ",", 
         RowBox[{"\<\"iorigin\"\>", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}]}]}], "}"}], ",", 
       RowBox[{"\[LeftSkeleton]", "140", "\[RightSkeleton]"}], ",", 
       RowBox[{"{", "}"}]}], "}"}]}], ",", 
    RowBox[{"\[LeftSkeleton]", "3", "\[RightSkeleton]"}]}], "}"}],
  Short]], "Output",
 CellChangeTimes->{3.5082402539060307`*^9, 3.5082403102441683`*^9}]
}, Open  ]]
},
WindowSize->{640, 540},
WindowMargins->{{294, Automatic}, {Automatic, 1}},
ShowSelection->True,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 6, \
2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3508243905-7089979"->{
  Cell[2834, 91, 441, 8, 76, "Print",
   CellTags->"Info3508243905-7089979"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3508243905-7089979", 13407, 387}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 263, 5, 27, "Input"],
Cell[811, 27, 116, 2, 27, "Input"],
Cell[930, 31, 129, 2, 26, "Text"],
Cell[CellGroupData[{
Cell[1084, 37, 117, 2, 27, "Input"],
Cell[1204, 41, 1471, 41, 73, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2712, 87, 119, 2, 27, "Input"],
Cell[2834, 91, 441, 8, 76, "Print",
 CellTags->"Info3508243905-7089979"]
}, Open  ]],
Cell[3290, 102, 89, 1, 26, "Text"],
Cell[3382, 105, 386, 7, 43, "Input"],
Cell[3771, 114, 151, 3, 26, "Text"],
Cell[CellGroupData[{
Cell[3947, 121, 311, 5, 27, "Input"],
Cell[4261, 128, 516, 11, 27, "Output"]
}, Open  ]],
Cell[4792, 142, 105, 1, 26, "Text"],
Cell[CellGroupData[{
Cell[4922, 147, 264, 5, 27, "Input"],
Cell[5189, 154, 847, 21, 27, "Output"]
}, Open  ]],
Cell[6051, 178, 127, 1, 26, "Text"],
Cell[CellGroupData[{
Cell[6203, 183, 817, 16, 58, "Input"],
Cell[7023, 201, 745, 19, 27, "Output"]
}, Open  ]],
Cell[7783, 223, 213, 6, 26, "Text"],
Cell[CellGroupData[{
Cell[8021, 233, 330, 6, 27, "Input"],
Cell[8354, 241, 738, 19, 27, "Output"]
}, Open  ]],
Cell[9107, 263, 133, 1, 26, "Text"],
Cell[CellGroupData[{
Cell[9265, 268, 223, 4, 27, "Input"],
Cell[9491, 274, 682, 20, 43, "Output"]
}, Open  ]],
Cell[10188, 297, 125, 1, 26, "Text"],
Cell[CellGroupData[{
Cell[10338, 302, 466, 7, 27, "Input"],
Cell[10807, 311, 897, 21, 43, "Output"]
}, Open  ]],
Cell[11719, 335, 198, 4, 26, "Text"],
Cell[CellGroupData[{
Cell[11942, 343, 346, 8, 43, "Input"],
Cell[12291, 353, 759, 19, 43, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
